{
  stdenv,
  lib,
  pnpm,
  nodejs,
  withBackendUrl ? "",
}:

stdenv.mkDerivation (finalAttrs: {
  pname = "web";
  version = "0.1";

  src = ../web;

  pnpmDeps = pnpm.fetchDeps {
    inherit (finalAttrs) pname version src;
    hash = "sha256-Xo21F4xWsXKusx+gdTSvF5GKw/Zh1iCoqm0mr0YvEO8=";
  };

  nativeBuildInputs = [
    nodejs
    pnpm.configHook
  ];

  env.VITE_BACKEND_URL = withBackendUrl;

  buildPhase = ''
    runHook preBuild

    pnpm buildNoCheck

    runHook postBuild
  '';

  installPhase = ''
    runHook preInstall

    mkdir -p $out
    cp -r dist/* $out

    runHook postInstall
  '';

  buildInputs = [ ];

  dontStrip = true;

  meta = with lib; {
    platforms = lib.platforms.all;
  };
})
